



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>怎么查找执行比较慢的sql语句-DBA给的建议</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">怎么查找执行比较慢的sql语句-DBA给的建议</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 08:20:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li>1.使用sql动态视图</li></ul>
<p>如下：</p>
<div>
<pre class="prettyprint linenums">select top 10 b.text,a.total_worker_time,a.total_logical_reads,a.total_elapsed_time,execution_count<br />
from sys.dm_exec_query_stats a<br />
CROSS APPLY sys.dm_exec_sql_text(a.sql_handle) as b<br />
order by total_worker_time/execution_count desc </pre>
</div>
<p>查看联机帮助文档视图：sys.dm_exec_query_stats可得到所有字段含义，主要有</p>
<p>total_worker_time：总的cpu消耗时间</p>
<p>total_logical_reads：逻辑读次数</p>
<p>total_elapsed_time：耗时</p>
<p>execution_count：执行次数。</p>
<p>total_worker_time/execution_count desc 表示每次执行需要消耗多少cpu，按照倒叙排序，找到最消耗cpu的sql语句。text</p>
<p>上面只可以查找SqlServer清空缓存之后的数据，如果SqlServer重启过，或者SqlServer由于内存不足导致执行计划被释放。那么是无法找到的。</p>
<ul><li>2.使用攻击profiler。新建跟踪：</li></ul>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/307536/201504/162139032457644.x-png" /></p>
<p>勾选以下事件。第一个是存储过程，第二个是sql语句</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/307536/201504/162139300422525.x-png" /></p>
<p>筛选器选择超过100秒的为慢sql（单位为毫秒），点击确定。如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/307536/201504/162139493543224.x-png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j0wz0q.html">yii2创建数据表</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwjvvl8.html">OpenCV笔记大集锦（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7z2jj9.html">获取json数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4dgd9.html">如何使用Chrome Timeline 工具（译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/495eeem9.html">Hive安装与部署集成mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/495650v8.html">【BZOJ】1098&colon; &lbrack;POI2007&rsqb;办公楼biu（补图&plus;bfs&plus;链表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn7krq.html">java中汉字自动转换成拼音</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnokge8.html">剖析OkHttp缓存机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdk0348.html">C&num;中this在构造函数时的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvg33q.html">&lbrack;Tommas&rsqb; SQL 中 WITH AS 的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znxk29.html">加JENKINS的SLAVE节点（LINUX）要注意的事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydplegq.html">&num;include &amp;lt&semi;string&period;h&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzrye9.html">&lpar;转&rpar;CreateThread与&lowbar;beginthreadex本质区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xl2e8.html">libuv 与 libev 的对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpnn339.html">mysql 不同语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yd73g8.html">FastJson的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mem748.html">在内存充足时malloc函数分配内存失败的原因及解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/95015e68.html">pycharm&plus;django之小试牛刀</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zon1wnq.html">Live555 直播源  以及MediaSubsession</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjmx0z8.html">spring&colon;org&period;springframework&period;web&period;servlet&period;DispatcherServlet noHandlerFound解决方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/g8ep5vz9.html">ecshop数据库操作函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gndel8.html">shell 中的数学计算</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9665139.html">DropzoneJS 使用指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/4955j509.html">关于集合的练习P235-1&comma;2&comma;3</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oxgnx8.html">Linux下监控磁盘使用量并在超过阀值后自动发送报警邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/m966y749.html">laravel  部分路由取消csrf</a>
			</li>
						<li><a href="https://www.batexi.com/a/4955zpm9.html">【git】删除某个文件的所有历史记录，批量删除远程分支</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gnr7z8.html">nusoap</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7pj5jq.html">C&plus;&plus;线程池的实现&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8ep2wm9.html">&period;Net程序员安卓学习之路1：登陆界面</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
